IOP.METRICS = function() {
	
	/**
	 * This function fetches the internal stats from the JSON based controller
	 *
	 */
    var showInternalStats = function(e) {
		//reset the error message which will be shown as server side check
		$('#internalStatsErrorId').addClass("hideMetrics");
	    $(".tabs div.abst .metrics-panel ul.internal-stats").css("height","115px");
		//i.e. downloads empty is true
		$('#internalStatsAjaxLoader').removeClass("hideAjaxLoader");
    	var articleID = $("#articleID").text() 
    	var showCutoffMessage = $("#internalStatsCutoffId").text() 
    	if (showCutoffMessage) {
    		$('#internalStatsCutoffMsgId').removeClass("hideMetrics");
    	}
		IOP.ajax.getJson({
			location: "/almController?method=getInternalStats&articleId=" + articleID,
			
			errorMsg: null,
			success: function(data) {
				$('#internalStatsAjaxLoader').addClass("hideAjaxLoader");
				if (!data.internalStatsObj) {
				    $(".tabs div.abst .metrics-panel ul.internal-stats").css("height","0px");
					$('#internalStatsHeader').addClass("hideMetrics");
					$('#internalStatsErrorId').removeClass("hideMetrics");
					$('#intenalArticleStatsId').removeClass("intenalArticleStats");
					$('#internalStatsHeaderId').addClass("hideMetrics");
				} else { 
					$(".tabs div.abst .metrics-panel ul.internal-stats").css("height","115px");
					$('#internalStatsDownloadsId').html(data.internalStatsObj.downloads);
					$('#internalStatsHeader').removeClass("hideMetrics");
					$('#internalStatsHeaderId').removeClass("hideMetrics");
					$('#intenalArticleStatsId').addClass("intenalArticleStats");
				} 
			}
		});
    };
    
    /**
	 * This function fetches the internal stats from the JSON based controller
	 *
	 */
    var showExternalStats = function(e) {
		$('#thirdPartyStatsErrorId').addClass("hideMetrics");

    	var articleID = $("#articleID").text()
    	var doi = $("#doi").text() 
    	var showVideo = $("#showVideoId").text()
    	
		$('#thirdPartyStatsAjaxLoader').removeClass("hideAjaxLoader");

		IOP.ajax.getJson({
			location: "/almController?method=getExternalStats&articleId=" + articleID + "&doi=" + doi,

			errorMsg: null,
			success: function(data) {
				var videosPresent = false;
				$('#thirdPartyStatsAjaxLoader').addClass("hideAjaxLoader");

				if (!data.externalStatsArr) {
					$('#thirdPartyStatsErrorId').removeClass("hideMetrics");
					//since google scholar is always displayed, hide it in case service is not available
					$('#googlescholarId').addClass("hideMetrics");
				} 
				jQuery.each(data.externalStatsArr, function() {
					$('#thirdPartyStatsErrorId').addClass("hideMetrics");
					//remove the hidemetrics added by server side code
					//since third party service is available
					$('#citationsSectionId').removeClass("hideMetrics");
					$('#bookmarksSectionId').removeClass("hideMetrics");
					$('#googlescholarId').removeClass("hideMetrics");
					
					//this check will check for JSONObjects which don't have error in them
					//in case of error, the id, count and landing page are not received from the xml
					if (this.error) {
						var errorId = '#' + this.id + 'ErrorId';
						$(errorId).removeClass("hideMetrics");
						$(errorId).addClass("metricsError");
				
					} else {
						if (this.count > 0 || this.id == 'googlescholar') {
							var liID = '#' + this.id + 'Id';
							$(liID).removeClass("hideMetrics");
							var anchorTagID = '#' + this.id + 'Id a';
							$(anchorTagID).attr("href", this.landingpage);
							var countID = '#' + this.id + 'CountId';
							if ($(countID)) {
								$(countID).text(this.count);
							}
						}
					}
				});

				//show the Video header only if videos are present in the article.
				if (showVideo == 'true') {
					$('#videoSectionId').removeClass("hideMetrics");
				}

				//this is to remove the default firstMetrics class added by server side code
				$("#googlescholarId").removeClass("firstMetrics");
				$(".citations-shares").each(function() {
					$(this).find("li:visible").first().addClass("firstMetrics");
				})
			}
		});
    };

	/**
	 * Toggles the class for showing the metrics tab highlighted 
 	 * and other tabs not selected
	 */
	var toggleOnClassForTab = function(e) {
		$('#metricsDisplayLink').addClass("on");
		if($("#citationsDisplayLink").get(0)){
			$('#citationsDisplayLink').removeClass("on");
		}
		if($("#articleDisplayLink").get(0)){
			$('#articleDisplayLink').removeClass("on");
		}
		if($("#referenceDisplayLink").get(0)){
			$('#referenceDisplayLink').removeClass("on");
		}
		if($("#multimediaDisplayLink").get(0)){
			$('#multimediaDisplayLink').removeClass("on");
		}
		if($("#tablesDisplayLink").get(0)){
			$('#tablesDisplayLink').removeClass("on");
		}
		if($("#figuresDisplayLink").get(0)){
			$('#figuresDisplayLink').removeClass("on");
		}
	}
	
	/**
	 * Toggles the class for showing the metrics tab highlighted 
 	 * and other tabs not selected for mobile view.
	 */
	var toggleOnClassForTabForMobileView = function(e) {
		$('#mobileMetricsDisplayLink').addClass("selectedTabLink");
		if($("#mobileAbstractDisplayLink").get(0)){
			$('#mobileAbstractDisplayLink').removeClass("selectedTabLink");
		}
		if($("#mobileFiguresDisplayLink").get(0)){
			$('#mobileFiguresDisplayLink').removeClass("selectedTabLink");
		}
		if($("#mobileTablesDisplayLink").get(0)){
			$('#mobileTablesDisplayLink').removeClass("selectedTabLink");
		}
		if($("#mobileReferencesDiplayLink").get(0)){
			$('#mobileReferencesDiplayLink').removeClass("selectedTabLink");
		}
		if($("#mobileCitedByDisplayLink").get(0)){
			$('#mobileCitedByDisplayLink').removeClass("selectedTabLink");
		}
		if($("#mobileSupplementaryDisplayLink").get(0)){
			$('#mobileSupplementaryDisplayLink').removeClass("selectedTabLink");
		}
	}
    
    jQuery(document).ready(function() {
    	//Commented for Mobile view (not working)
    	/*$(".selectedTabLink").click(function(){
    		return false;
    	});*/
    		
		$('#abstractMoreMetricsId').click(function() {
			 if($("#mobileViewLinks").length > 0){
                 showMetricsForMobileView();
			 }else{
                 showMetrics();
			 }
			return false;
		});
    	$('#metricsDisplayLink').click(function() {
			showMetrics();
			//$.address.value('/metrics/');
			return false;
   		});
    	
    	$('#mobileMetricsDisplayLink').click(function() {
    		showMetricsForMobileView();
			return false;
   		});
    	
    });

	var showMetrics = function(e) {
		if (!$('#metricsDisplayLink').hasClass('on')) {
			var metricsContent = $('#metricsContentID').html();
			//resetting the hidden div to empty value such that setting the values would set in the div contents copied
			$('#metricsContentID').html('');

			$('#articleTabId').html(metricsContent);
			
			toggleOnClassForTab();
			showInternalStats();
			showExternalStats();
		}
	}
   
	var showMetricsForMobileView = function(e) {
		if (!$('#mobileMetricsDisplayLink').hasClass('selectedTabLink')) {
			var metricsContent = $('#metricsContentID').html();
			//resetting the hidden div to empty value such that setting the values would set in the div contents copied
			$('#metricsContentID').html('');

			$('#articleTabId').html(metricsContent);
			
			$('.summaryTitle').text("Metrics");
			toggleOnClassForTabForMobileView();
			showInternalStats();
			showExternalStats();
		}
	}
	
    return {
    };
    
}();